// -*- c++ -*- 
// src.y

%{
#include <stdio.h>
  //extern FILE* yyin;
int yyerror(char *);
extern int yylex();
%}

%union{
  char *id;
  int  junk;                    //only for irrelevant lexical values, such as IF ELSE WHILE.
  int  int_val;                 //values of integer literal
  //string      *str_val;             //values of string literals
  //program     *program;           //the non-terminal node, which is the start of the whole grammar
  //MainClass   *mainclass;  
  //Exp         *exp;               //A lot of expressions in the grammar should use this type
  //Statement   *statement;         // i.e. if, while statements 
  //ClassDec * classdec;          //Class  declaration
  //VarDec   * vardec;            //Variable declaration
  //MethodDec  * methoddec;       //Method (function) declaration
  //list <VarDec*>*  varlist;     //for function parameters and FormalList
  //list<Exp *> *  exps;          //Explist
  //list<Dec*> *  decs;           //VarDecl list, MethodDecl list, etc
  //list<Statement *> * states;   //Statement list
}
  
%token <id> ID
%token <int_val> INTEGER_CONST

%token CLASS
%token PUBLIC
%token STATIC
%token VOID
%token MAIN
%token STRING
%token RETURN
%token IF
%token ELSE
%token WHILE
%token SYSTEM
%token OUT
%token PRINTLN
%token LENGTH
%token THIS
%token NEW
%token INT
%token EXTENDS
%token BOOLEAN
%token RETURN

%left '[' ']'
%token '(' ')'
%token '{' '}'
%token ';'
%token ','
%left '.'
%token TRUE
%token FALSE

%nonassoc '='
%left'+' '-'
%left '*' 
%right '!'

%type <junk> program
%type <junk> mainclass
%type <junk> classdecls
%type <junk> classdecl
%type <junk> vardecls
%type <junk> vardecl
%type <junk> methoddecls
%type <junk> methoddecl
%type <junk> formallist
%type <junk> formalrests
%type <junk> type
%type <junk> statements
%type <junk> statement
%type <junk> exp
%type <junk> explist
%type <junk> exprests
%type <junk> exprest

%%
program:mainclass classdecls {}
;

mainclass:CLASS ID '[' PUBLIC STATIC VOID MAIN '(' STRING '[' ']' ID ')' {}
;

classdecls: {}
|classdecl classdecls {}
;

classdecl:CLASS ID '{' vardecls methoddecls '}' {}
|CLASS ID EXTENDS ID '{' vardecls methoddecls '}' {}
;

vardecls: {}
|vardecls vardecl {}
;

vardecl:type ID {}
;

methoddecls: {}
|methoddecl methoddecls {}
;

methoddecl:PUBLIC type ID '(' formallist ')' '{' vardecls statements RETURN exp ';' '}' {}
;

formallist: {}
|type ID formalrests {}
;

formalrests: {}
|',' type ID formalrests {}
;

type:INT '[' ']' {}
|BOOLEAN {}
|INT {}
|ID {}
;

statements: {}
|statement statements {}
;

statement:'{' statements '}' {}
|IF '(' exp ')' statement ELSE statement {}
|WHILE '(' exp ')' statement {}
|SYSTEM '.' OUT '.' PRINTLN '(' exp ')' ';' {}
|ID '=' exp ';' {}
|ID '[' exp ']' '=' exp ';' {}
;

exp:exp '+' exp {}
|exp '-' exp {}
|exp '*' exp {}
|exp '[' exp ']' {}
|exp '.' LENGTH {}
|exp '.' ID '(' explist ')' {}
|INTEGER_CONST {}
|TRUE {}
|FALSE {}
|ID {}
|THIS {}
|NEW INT '[' exp ']' {}
|NEW ID '(' ')' {}
|'!' exp {} 
|'(' exp ')' {}
;

explist: {}
|exp exprests {}
;

exprests: {}
|exprest exprests {}
;

exprest:',' exp {}
;

%%

int main(){
  yyparse();
}


/* int yyerror( string s) {  // error handler routine */
/* /\*   extern int  yylineno;    // defined and maintained in lex.c *\/ */
/* /\*   extern char* yytext;     // defined and maintained in lex.c *\/ */
/* /\*   cerr << "ERROR: " << s << " at symbol " << yytext; *\/ */
/* /\*   cerr << " on line " << yylineno << endl; *\/ */
/* /\*   exit(1); *\/ */
/* } */

int yyerror( char* s ) { }
